<script setup lang="ts">
import { RouterLink, RouterView } from "vue-router";
import { io } from "socket.io-client";
import { ref } from "vue";

const socket = io("http://localhost:3000");

const messages = ref<string[]>([]);
const newMessage = ref("");

function sendMessage() {
  console.log(newMessage.value);
  socket.emit("messageFromClient", newMessage.value);
  newMessage.value = "";
}

socket.on("messageFromServer", (message: string) => {
  console.log("messageFromServer", message);
  messages.value.push(message);
});
</script>

<template>
  <div class="appContainer">
    <div class="message-container">
      <div v-for="(message, index) in messages" :key="index" class="message">
        {{ message }}
      </div>
    </div>
    <div class="input-container">
      <input
        v-model="newMessage"
        class="message-input"
        placeholder="Tapez votre message ici..."
        @keyup.enter="sendMessage"
      />
      <button @click="sendMessage" class="send-button">Envoyer</button>
    </div>
  </div>
</template>

<style lang="scss">
.appContainer {
  display: flex;
  flex-direction: column;
  width: 600px;
  background: white;
  border-radius: 20px;
  margin: auto;
  height: 90%;
  position: absolute;
  transform: translate(-50%, -50%);
  top: 50%;
  left: 50%;
}

.message-container {
  flex: 1;
  overflow-y: auto;

  &:-webkit-scrollbar {
    width: 0;
    height: 0;
  }
}
.message-container::-webkit-scrollbar {
  width: 0;
  height: 0;
}

.message {
  margin: 20px;
  width: 560px;
  background: #4169e1;
  padding: 15px;
  border-radius: 20px;
  color: white;
}

.input-container {
  display: flex;
  align-items: center;
  input {
    border-radius: 0 0 0 20px;
    height: 50px;
  }
}

.message-input {
  flex: 1;
  padding: 8px 20px;
  border: transparent;
  border-top: 1px solid #4169e1;
  outline: none;
  color: #4169e1;
}

.send-button {
  padding: 8px 30px;
  background-color: #4169e1;
  color: #fff;
  border: none;
  cursor: pointer;
  height: 50px;
  border-radius: 0 0 20px 0;
  font-size: 16px;
}

.send-button:hover {
  background-color: #0056b3;
}
</style>
